// import md5 from 'md5'

export function request(url, options = {}) {
  const config = useRuntimeConfig();
  // const authStore = useAuthStore()
  // const { token } = storeToRefs(authStore)
  const defatulOpts = {
    method: "get",
    baseURL: config.public.baseApi,

    headers: {
      ...options.headers,
      "Content-Type": "application/json",
      // deviceType: config.public.deviceType,
      // token: token.value ? JSON.parse(token.value) : ''
    },
    onRequest({ options }) {
      if (options.method === "post") {
        // const bodyJson = options.body ? JSON.stringify(options.body) : ''
        // const timestamp = new Date().getTime()
        // let sign = `yingdeweilai888${bodyJson}${timestamp}`
        // sign = md5(sign).toUpperCase()
        // options.headers.sign = sign
        // options.headers.timestamp = timestamp
      }
    },
    onRequestError() {
      // showErrorMessage('请求出错，请重试~')
    },
    onResponse({ response: { _data: data } }) {
      if (data && data.errorCode != "NO-ERROR") {
        handleServerError(data.errorCode, data.errorMessage);
      }
    },
    onResponseError({ response }) {
      handleHttpError(response.status);
    },
    ...options,
  };
  return new Promise((resolve, reject) => {
    $fetch(url, defatulOpts)
      .then((res) => {
        const { errorCode } = res;
        errorCode === "NO-ERROR" ? resolve(res) : reject(res);
      })
      .catch((err) => reject(err));
  });
}

const handleHttpError = (status) => {
  switch (status) {
    case 400:
      showErrorMessage("参数错误");
      break;
    case 401:
      showErrorMessage("没有访问权限");
      break;
    case 403:
      showErrorMessage("服务器拒绝访问");
      break;
    case 404:
      showErrorMessage("请求地址错误");
      break;
    case (502, 503):
      showErrorMessage("系统升级中");
      break;
    default:
      showErrorMessage("服务器出错了");
      break;
  }
};

const handleServerError = async (code, msg) => {
  // const authStore = useAuthStore()
  // if (code === 401) {
  //   authStore.cleanToken()
  //   await navigateTo({
  //     replace: true
  //   })
  //   return
  // }
  if (msg) {
    showErrorMessage(msg);
  }
};

const showErrorMessage = (msg) => {
  // const { message } = createDiscreteApi(['message'])
  // if (process.server) return
  // const { message } = useMessage()
  // message.error(msg)
};
